// title: UM camera holder
// author: Peter Uithoven
// license: Creative Commons CC BY
// URL: 
// revision: 0.000
// tags: camera,um2,mount

cameraWidth = 32;
cameraHeight = 32;
thickness = 1.5;
cameraHoleW = 17.5;
cameraHoleH = 16.5;
cameraHandleW = 4.5; // handle that mount camera mount width
cameraHandleH = 4; // handle that mount camera mount height
cameraHandleD = 4; // handle that mount camera mount depth

roundRadius = 2;
//boltR = 2.5/2;
//boltDistance = 28; // distance between bolt's centers
JSTConW = cameraWidth-10*2;
JSTConH = 4;

o = 0.1; // slight overlap
$fs = 0.5; 
$fa = 5; 

cameraHolderCover();

//rotate([-90,0,0]) translate([0,-cameraHeight,0]) cameraHolderCover();


module cameraHolderCover() {
  linear_extrude(thickness) difference() {
    roundedSquare([cameraWidth,cameraHeight]);
    // JST connector pins
    translate([(cameraWidth-JSTConW)/2,cameraHeight-JSTConH]) square([JSTConW,JSTConH+o]);
    // Camera
    translate([(cameraWidth-cameraHoleW)/2,(cameraHeight-cameraHoleH)/2]) square([cameraHoleW,cameraHoleH]);
    // Camera handles
    translate([cameraWidth/2,(cameraHeight-cameraHandleH)/2]) cloneMirrored(cameraHoleW-o*2) square([cameraHandleW+o,cameraHandleH]);
  }
}

/////////////////////////////// UTILS ///////////////////////////////
module roundedSquare(pos=[10,10],rounding=2,center=false) {
	offset = (center)? 0 : rounding;
	translate([offset,offset]) minkowski() {
		square([pos[0]-rounding*2,pos[1]-rounding*2],center=center);
		circle(rounding);
	}
}
// clone children and put a disX (and disY) between them
module cloneMirrored(disX=0,disY=0) {
	translate([ disX/2, disY/2, 0]) children();
	translate([-disX/2, disY/2, 0]) scale([-1,1,1]) children();
	if(disY > 0) {
		translate([ disX/2, -disY/2, 0]) children();
		translate([-disX/2, -disY/2, 0]) scale([-1,1,1]) children();
	}
}